OGRE-Next: Ogre::CompositorPassQuad Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Public Member Functions | List of all members
Ogre::CompositorPassQuad Class Reference
Core » Effects

Implementation of CompositorPass This implementation will render a fullscreen triangle/quad to the RenderTarget using the parameters from definition (rectangle area, whether triangle or quad pass, whether to include frustum corners, etc) More...

`#include <OgreCompositorPassQuad.h>`

Inheritance diagram for Ogre::CompositorPassQuad:
[legend]

## Public Member Functions
| CompositorPassQuad (const CompositorPassQuadDef *definition, Camera *defaultCamera, CompositorNode *parentNode, const RenderTargetViewDef *rtv, Real horizonalTexelOffset, Real verticalTexelOffset)
| ~CompositorPassQuad () override
void | execute (const Camera *lodCamera) override
Camera * | getCamera ()
Pass * | getPass ()
| Don't make this const (useful for compile-time multithreading errors) Pointer can be null if using HLMS.
Public Member Functions inherited from Ogre::CompositorPass
| CompositorPass (const CompositorPassDef *definition, CompositorNode *parentNode)
virtual | ~CompositorPass ()
ResourceTransitionArray & | _getResourceTransitionsNonConst ()
Vector2 | getActualDimensions () const
const CompositorPassDef * | getDefinition () const
const CompositorNode * | getParentNode () const
RenderPassDescriptor * | getRenderPassDesc () const
const ResourceTransitionArray & | getResourceTransitions () const
const CompositorTextureVec & | getTextureDependencies () const
CompositorPassType | getType () const
Real | getViewportAspectRatio (size_t vpIdx)
virtual void | notifyCleared ()
virtual void | notifyDestroyed (const UavBufferPacked *buffer)
virtual void | notifyDestroyed (TextureGpu *channel)
virtual bool | notifyRecreated (const TextureGpu *channel)
virtual void | notifyRecreated (const UavBufferPacked *oldBuffer, UavBufferPacked *newBuffer)
void | profilingBegin ()
void | profilingEnd ()
virtual void | resetNumPassesLeft ()

## Detailed Description

Implementation of CompositorPass This implementation will render a fullscreen triangle/quad to the RenderTarget using the parameters from definition (rectangle area, whether triangle or quad pass, whether to include frustum corners, etc)

  A fullscreen quad are two triangles that form a rectangle, which cover the entire screen. This is however an inefficient way of harnessing the GPU's power. Modern GPUs iterate a whole bounding rect that encloses each triangle (it's highly more parallelizable & scalable than the scanline algorithm used by older Voodoo cards in the 90's). That means we're wasting 50% of GPU reasources in pixels that aren't drawn.

  A much faster approach made famous by Emil Persson (see max area triangulation http://www.humus.name/index.php?page=News&ID=228) is to render a single oversized triangle that covers the entire screen, which has it's UV scaled up; so that when interpolated at screen position, it appears it goes from the range [0; 1) like a regular quad pass. The difference is that pixels that go past the viewport are much better clipped/earlied-out by the GPU than those that fall inside the viewport but outside the triangle (like the rectangle approach)

  This faster technique only works for passes that cover the entire screen. When the viewport is not 0 0 1 1; the CompositorPassQuad automatically switches to a fullscreen quad.

  IMPORTANT: The texel-to-pixel adjustment offset is included in the world matrix passed to the vertex shader. This differs from Ogre 1.x which tried to embed the offset into the vertices.

  IMPORTANT: When the viewport is not 0 0 1 1; the scale & position factors are passed through the world matrix. This behavior differs from Ogre 1.x

Author
  Matias N. Goldberg

Version
  1.0

## Constructor & Destructor Documentation

## ◆ CompositorPassQuad()

Ogre::CompositorPassQuad::CompositorPassQuad | ( | const CompositorPassQuadDef * | definition,
|  | Camera * | defaultCamera,
|  | CompositorNode * | parentNode,
|  | const RenderTargetViewDef * | rtv,
|  | Real | horizonalTexelOffset,
|  | Real | verticalTexelOffset )

## ◆ ~CompositorPassQuad()

Ogre::CompositorPassQuad::~CompositorPassQuad | ( |  | ) |
| override

## Member Function Documentation

## ◆ execute()

void Ogre::CompositorPassQuad::execute | ( | const Camera * | lodCamera | ) |
| overridevirtual

Implements Ogre::CompositorPass.

## ◆ getCamera()

Camera * Ogre::CompositorPassQuad::getCamera | ( |  | ) |
| inline

## ◆ getPass()

Pass * Ogre::CompositorPassQuad::getPass | ( |  | ) |
| inline

Don't make this const (useful for compile-time multithreading errors) Pointer can be null if using HLMS.

The documentation for this class was generated from the following file:

- OgreCompositorPassQuad.h